﻿using System;
using System.Data;
using System.Web;
using System.Data.SqlClient;
using System.Web.Hosting;

public class SqlLoggingMdoule : IHttpModule
{
    public void Dispose() {
    }

    public void Init(HttpApplication context) {
        context.LogRequest += new EventHandler(context_LogRequest);
    }

    void context_LogRequest(object sender, EventArgs e) {

        HttpApplication app = (HttpApplication)sender;
        LogRequest(app.Context);
    }

    private void LogRequest(HttpContext ctx) {
        string connectionString = "server=(local);database=DevConnections;uid=user;password=password";

        // Disable Kernel Cache
        ctx.Response.DisableKernelCache();

        using (SqlConnection connection = new SqlConnection(connectionString)) {

            SqlCommand cmd = connection.CreateCommand();
            cmd.CommandText =
                "insert into Log (Date, Method, IPAddress, Url, UserName, UserAgent, ResponseCode, SiteName, ApplicationName) values" +
                              "(@Date, @Method, @IPAddress, @Url, @UserName, @UserAgent, @ResponseCode, @SiteName, @ApplicationName)";

            cmd.Parameters.AddWithValue("@Date", DateTime.Now);
            cmd.Parameters.AddWithValue("@Method", ctx.Request.HttpMethod);
            cmd.Parameters.AddWithValue("@IPAddress", ctx.Request.UserHostAddress);
            cmd.Parameters.AddWithValue("@Url", ctx.Request.Url.ToString());
            cmd.Parameters.AddWithValue("@UserName", ctx.Request.ServerVariables["LOGON_USER"]);
            cmd.Parameters.AddWithValue("@UserAgent", ctx.Request.UserAgent);
            cmd.Parameters.AddWithValue("@ResponseCode", ctx.Response.StatusCode + "." + ctx.Response.SubStatusCode);
            cmd.Parameters.AddWithValue("@SiteName", HostingEnvironment.SiteName);
            cmd.Parameters.AddWithValue("@ApplicationName", ctx.Request.ApplicationPath);

            connection.Open();
            cmd.ExecuteNonQuery();
        }
    }
}
